// Learn cc.Class:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/class.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/class.html
// Learn Attribute:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/life-cycle-callbacks.html
cc.Class({
    extends: cc.Component,

    properties: {
        DrawGraphics: cc.Node,
    },

    // LIFE-CYCLE CALLBACKS:
    ctor() {

    },
    onLoad() {
        this.drawCircleCache = [];
        this.graphics = this.DrawGraphics.getComponent(cc.Graphics);
    },
    start() {
        let draw_datas = [
            {
                x: 2.94,
                y: 35.3,
                r: 320.79,
                color: "#000000"
            },
            {
                x: 1.5,
                y: 38.18,
                r: 285.27,
                color: "#f9a8a6"
            },
            {
                x: -1.38,
                y: -123.1,
                r: 159.84,
                color: "#000000"
            },
            {
                x: -44.58,
                y: -36.7,
                r: 157.25,
                color: "#f9a8a6"
            },
            {
                x: -27.3,
                y: -61.18,
                r: 174.27,
                color: "#f9a8a6"
            },
            {
                x: -190.02,
                y: -202.3,
                r: 121.73,
                color: "#208200"
            },
            {
                x: 100.86,
                y: -241.18,
                r: 122.84,
                color: "#208200"
            }
        ];

        let self = this;
        draw_datas.forEach(c => {
            self.drawCircle(self.graphics,c.x,c.y,c.r,c.color);
        });
    },
    clearDrawPanel(g) {
        g.clear();
        this.drawCircleCache = [];
    },

    drawCircle(g, cx, cy, r, hexColor) {
        cx = Number(cx.toFixed(2));
        cy = Number(cy.toFixed(2));
        r = Number(r.toFixed(2));
        this.drawCircleCache.push({g : g,x : cx, y : cy, r : r, c : hexColor});
    },
    update (dt) {
        // 缓存重绘
        if (this.drawCircleCache.length > 0) {
            let rm = this.drawCircleCache.splice(0,30);
            for (let i = 0; i < rm.length; ++i) {
                let g = rm[i].g;
                g.fillColor.fromHEX(rm[i].c);
                g.circle(rm[i].x, rm[i].y, rm[i].r);
                g.fill();
            }
        }
    },
});