cc.Class({
    extends: cc.Component,

    properties: {
        DestCamera: cc.Camera,
        DestLevelSprite: cc.Sprite,
        SrcCamera: cc.Camera,
        RenderCamera : cc.Camera,
        RenderSprite : cc.Sprite,

        DestReferenceSprite: cc.Sprite,
        SrcReferenceSprite: cc.Sprite,
    },

    // LIFE-CYCLE CALLBACKS:
    ctor() {

    },
    onLoad() {

    },
    start() {

        this.destTex = new cc.RenderTexture();
        this.destTex.initWithSize(this.DestCamera.node.width, this.DestCamera.node.height);
        this.DestCamera.targetTexture = this.destTex;

        this.srcTex = new cc.RenderTexture();
        this.srcTex.initWithSize(this.SrcCamera.node.width, this.SrcCamera.node.height);
        this.SrcCamera.targetTexture = this.srcTex;

        this.renderTex = new cc.RenderTexture();
        this.renderTex.initWithSize(this.RenderCamera.node.width, this.RenderCamera.node.height);
        this.RenderCamera.targetTexture = this.renderTex;

        let sf = new cc.SpriteFrame();
        sf.setTexture(this.renderTex);
        this.RenderSprite.spriteFrame = sf;

        this.updateReference();

    },
    autoCheckPiexls() {
        this.updateReference();
    },
    updateReference() {
        if (CC_WECHATGAME) {
            this.DestReferenceSprite.node.active = false;
            this.SrcReferenceSprite.node.active = false;
        }
        else {
            let destSf = new cc.SpriteFrame();
            destSf.setTexture(this.destTex);
            this.DestReferenceSprite.spriteFrame = destSf;
            this.DestReferenceSprite.node.active = true;

            let srcSf = new cc.SpriteFrame();
            srcSf.setTexture(this.destTex);
            this.SrcReferenceSprite.spriteFrame = srcSf;
            this.SrcReferenceSprite.node.active = true;
        }
    },
    setDestLevelSprite(spriteFrame) {
        this.DestLevelSprite.spriteFrame = spriteFrame;
    }
});